#ifndef __SOCKET_H__ 
#define __SOCKET_H__

#ifdef _WIN32
#include <windows.h>
#include <tchar.h>
#endif

#include "lin_tchar.h"


#ifdef _WIN32
	typedef int socklen_t;
#else
	#include <sys/socket.h>
	#define INVALID_SOCKET	-1
	#define SOCKET_ERROR	-1
	typedef int SOCKET;
#endif

#include "config.h"


class ClSocket
{
public:
	ClSocket();
	ClSocket( SOCKET socket );
	virtual ~ClSocket();

	int getStatus( void );
	void setStatus( int status );
	int getData( char* buffer , int buffSize );
	int sendData( const char* buffer , int buffSize );
	int getLine( _TCHAR* buffer, int buffSize );
	int sendLine( const _TCHAR* buffer, int buffSize );
	inline SOCKET& getSocket()
	{
		return m_socket;
	}
	void setSocket( SOCKET sock );
	static bool initSocketLibrary( void );
	static void closeSocketLibrary( void );

protected:
	void setBlocking( SOCKET sock, bool bBlocking );

protected:
	SOCKET m_socket;
	int m_socketStatus;
	static bool m_initialized;
	bool m_bBlocking;

};

#endif //__SOCKET_H__
