
#include "RWMutex.h"

RWMutex::RWMutex ()
 :SysMutex ()
{
	m_count = 0;
}

RWMutex::~RWMutex()
{
}

bool RWMutex::readLock( void )
{
	if( m_lock.lock() )
	{
		if( m_count == 0 )
		{
			if( !lock() )
			{
				m_lock.unlock();
				return false;
			}
		}
		m_count ++;
		m_lock.unlock();
		return true;
	}
	return false;
}

void RWMutex::readUnlock( void )
{
	if( m_lock.lock() )
	{
		if( m_count == 1 )
		{
			unlock();
		}
		m_count --;
		m_lock.unlock();
	}
}

unsigned int RWMutex::getCount( void )
{
	return m_count;
}

void RWMutex::destroy( void )
{
	m_lock.destroy();
	SysMutex::destroy();
}
