
#if !defined (__RWMUTEX_H__)
#define __RWMUTEX_H__

#include "SysMutex.h"

//Mutex with read / write protection

class RWMutex:public SysMutex
{
public:
	//Create a new object
	RWMutex();

	//Destructor
	virtual ~RWMutex();

	//Lock for reading
	bool readLock( void );

	//Unlock after read
	void readUnlock( void );

	//Get number of clients in critical section
	//    return - client count
	unsigned int getCount( void );
	
	//Destroy the critical section
	void destroy( void );

private:
	//Lock Mutex
	SysMutex m_lock;

	//Critical section object counter
	unsigned int m_count;
};

#endif //__RWMUTEX_H__
