
#include "ServerSocket.h"

#ifndef _WIN32
#include <netinet/in.h>
#endif

ServerSocket::ServerSocket( int port)
{
	m_port = port;
}

ServerSocket::~ServerSocket()
{
}

bool ServerSocket::makeSocket( void )
{	
	struct sockaddr_in socketInfo;
	SOCKET sock = socket( AF_INET, SOCK_STREAM, 0 );
	if( sock == INVALID_SOCKET )
	{
		return false;
	}
#ifdef _WIN32
	int noDelay = 1;
	if( setsockopt( sock, IPPROTO_TCP, TCP_NODELAY, (const char* )&noDelay, sizeof( noDelay ) ) != 0 )
	{
		Socket sk( sock );
		sk.setStatus( -1 );
		return false;
	}
#else
	int tmp=1;
	setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, &tmp, sizeof(int));
#endif

	socketInfo.sin_family = AF_INET;
	socketInfo.sin_port = htons( m_port );
	socketInfo.sin_addr.s_addr = htonl( INADDR_ANY );

	int status = bind( sock, (struct sockaddr* )&socketInfo, sizeof( struct sockaddr_in ) );
	if( status == SOCKET_ERROR )
	{
		Socket sk( sock );
		sk.setStatus( -1 );
		return false;
	}
	setSocket( sock );
	listen( getSocket(), 100 );
	return true;
}


SOCKET ServerSocket::acceptSocket( struct sockaddr* sad )
{
	if ( m_socket == INVALID_SOCKET )
	{
		return INVALID_SOCKET;
	}
	
	struct sockaddr socketAddress;
	socklen_t size = sizeof( struct sockaddr );
	SOCKET sock = accept( m_socket, &socketAddress, &size );
	if( sad != NULL )
	{
		memcpy( sad, &socketAddress, size );
	}

	return sock;
}

