
#if !defined( __SOCKET_H__ )
#define __SOCKET_H__

#include "config.h"
#ifdef _WIN32
#include <tchar.h>
#else
#include "lin_tchar.h"
#endif

#ifdef _WIN32
typedef int socklen_t;
#else
#include <sys/socket.h>
#define INVALID_SOCKET	-1
#define SOCKET_ERROR	-1
typedef int SOCKET;
#endif

class Socket
{
public:
	Socket();
	Socket( SOCKET socket );
	virtual ~Socket();

	int getStatus( void );
	void setStatus( int status );
	int getData( char* buffer , int buffSize );
	int sendData( const char* buffer , int buffSize );
	int getLine( _TCHAR* buffer, int buffSize );
	int sendLine( const _TCHAR* buffer, int buffSize );
	inline SOCKET& getSocket()
	{
		return m_socket;
	}
	void setSocket( SOCKET sock );
	static bool initSocketLibrary( void );
	static void closeSocketLibrary( void );

protected:
	SOCKET m_socket;
	int m_socketStatus;
	static bool m_initialized;
};

#endif //__SOCKET_H__
