#pragma once

#include <list>
using namespace std;

#include "SysMutex.h"

template <class T>
class CSysQueue : public SysMutex
{
public:

	CSysQueue(void){}
	~CSysQueue(void){}

	void push_item(T item);

	size_t getSize();

	T pop_item();

	void removeAll( void );

private:
	list<T> m_elements;
};

template <class T>
void CSysQueue<T>::push_item(T item)
{
	// lock mutex
	lock();

		m_elements.push_back( item );

	// unlock mutex
	unlock();
}

template <class T>
size_t CSysQueue<T>::getSize()
{
	return ( m_elements.size() );
}

template <class T>
T CSysQueue<T>::pop_item()
{
	T item = NULL;

	// lock mutex
	lock();

		item = *m_elements.begin();
		m_elements.pop_front();

	// unlock mutex
	unlock();

	return item;
}

template <class T>
void CSysQueue<T>::removeAll( void )
{
	// lock mutex
	lock();

		m_elements.clear();

	// unlock mutex
	unlock();
}
