
#if !defined( __SYSTHREAD_H__ )
#define __SYSTHREAD_H__

#include "config.h"

#ifndef _WIN32
#include <pthread.h>
typedef pthread_t HANDLE;
#endif

class SysThread
{
public:
	SysThread( void );
	virtual ~SysThread();
	virtual bool start( void );
	virtual bool stop( unsigned int timeout = 0 );
	inline volatile bool& isRunning( void )
	{
		return m_bRunning;
	}
	inline volatile bool& isExited( void )
	{
		return m_bExited;
	}

protected:
	virtual void run( void );

private:
#ifdef _WIN32
	friend DWORD WINAPI runStub( LPVOID mthread );
#else
	friend void* runStub( void* mthread );
#endif

public:
	static const unsigned int INFINITE_WAIT;

private:
	volatile bool m_bRunning;
	volatile bool m_bExited;
	HANDLE m_thread;
};

#endif //__SYSTHREAD_H__
